C*********************************************************************
      subroutine rowi(mat,n,m,ii,r)
      integer ii,n,m
      double precision mat(n,m),r(m)
      do 10 i=1,m
		r(i)=mat(ii,i)
10    continue
      return
      end
C******************************************************************** 
        function rangen(init)
        integer a,p,ix,b15,b16,xhi,xalo,leftflo,fhi,k,init
        data a/16807/,b15/32768/,b16/65536/,p/2147483647/
        save ix
        if(init.ne.0) ix=init
        xhi=ix/b16
        xalo=(ix-xhi*b16)*a
        leftflo=xalo/b16
        fhi=xhi*a+leftflo
        k=fhi/b15
        ix=(((xalo-leftflo*b16)-p)+(fhi-k*b15)*b16)+k
        if (ix.lt.0)ix=ix+p
        rangen=ix*4.656612875E-10
        return
        end
C********************************************************************
        subroutine rngs(seed)
C initializes rangen with seed
        integer seed
	real rangen
	external rangen
        tmp=rangen(seed)
        return
        end
C*********************************************************************
	subroutine generate(u)
	double precision u
	real rangen
	external rangen
	u=dble(rangen(0))
	return
	end
C*********************************************************************
      double precision function dotmat(left,right,n)
      double precision sum,left(n),right(n)
      integer n
      sum=0.0D0
      do 5 i=1,n
        sum=sum+left(i)*right(i)
5     continue
      dotmat=sum
      return
      end
C*********************************************************************
      double precision function dotmatw(left,w,right,n)
      double precision sum,left(n),right(n),w(n)
      integer n
      sum=0.0D0
      do 5 i=1,n
        sum=sum+left(i)*w(i)*right(i)
5     continue
      dotmatw=sum
      return
      end
C*********************************************************************
      subroutine place(n,nsubset,ix,x,in,out,itemp)
C ix=c(ix1,ix2...), x=c(x1,...,xn), and if in<=x1, then out=ix(1),
C else if in<=x2, then out=ix(2) etc, otherwise out=-999
C checked OK Sept 18th 2001
      integer n,i,itemp,success,nsubset
      double precision ix(n),x(n),in,out
C      implicit none
      success=0
      do 10 i=1,nsubset
         itemp=i
      if (in.le.x(i)) then  
         success=1       
         go to 30          
      end if
10    continue
30    out=ix(itemp)
      if (success.eq.0) then
         out=-999.0D0
      end if
      return
      end     
C***************************************************************
      subroutine multinom(n,nsubset,ix,x,in,out,itemp)
C in is runiform, x=c(F(ix1),...,F(ixn)),F=cum distr
C ix=c(ix1,ix2...),  and if in<=x1, then out=ix(1),
C else if in<=x2, then out=ix(2) etc, otherwise out=-999

C checked OK Sept 18th 2001
      integer n,i,itemp,success,nsubset
      double precision ix(n),x(n),in,out
C      implicit none
      external place,generate
      in=0.0D0
      success=0
      call generate(in)
      do 10 i=1,nsubset
         itemp=i
      if (in.le.x(i)) then  
         success=1       
         go to 30          
      end if
10    continue
30    out=ix(itemp)
      if (success.eq.0) then
         out=-999.0D0
      end if
      return
      end
C***************************************************************
      subroutine findrfull(dbig,ebig,lengthofs,whatofs,probofs,
     >   nrbig,nd,ne,ns,nrfull,nsbig,sbig)
C constructs:
C   nsbig(nrbig): nsbig(ibig)= number of possible s's of ibig
C   nrfull      : sum(nsbig)
C   sbig(nrbig) : sbig(ibig) a random draw from the possible s
C                    (double prec.)
c input   
      INTEGER nrbig,nd,ne,ns
      INTEGER lengthofs(nd,ne)
      double precision dbig(nrbig),ebig(nrbig),whatofs(nd,ne,ns)
      double precision probofs(nd,ne,ns) 
C local 
      INTEGER dtemp,etemp,ifull,lengthofst,itemp
      double precision whatofst(ns),probofst(ns),u,s
c output  
      INTEGER nsbig(nrbig),nrfull
      double precision sbig(nrbig)
      external multinom      
C      IMPLICIT NONE
      itemp=1
      ifull = 0
      nrfull=0
      u=0.0D0
      do 10 ibig = 1,nrbig
      dtemp = int(dbig(ibig))
      etemp = int(ebig(ibig))+1
C find nsbig(ibig)=number of possible s values of ibig 
      lengthofst=lengthofs(dtemp,etemp)
      nsbig(ibig) = lengthofst
C update nrfull=sum(nsbig)
      nrfull=nrfull+nsbig(ibig)
       do 30 is=1,ns
         whatofst(is)=whatofs(dtemp,etemp,is)
         probofst(is)=probofs(dtemp,etemp,is)
30    continue
      call multinom(ns,lengthofst,whatofst,probofst,u,s,itemp)
      sbig(ibig)=s
 10   continue
      return
      end
c  *************************************************************
      subroutine createfull(databig,nrbig,ncbig,dcol,ecol,lengthofs,
     >nd,ne,whatofs,ns,datafull,nrfull,ncfull)
C constructs matrix expanded by possible s's.
c input     
      INTEGER nrbig,ncbig,dcol,ecol,nd,ne,ns,nrfull,ncfull
      INTEGER lengthofs(nd,ne)
      double precision databig(nrbig,ncbig),datafull(nrfull,ncfull)
      double precision whatofs(nd,ne,ns)      
C local and called functions and subs
      integer dobs, eobs       
C      IMPLICIT NONE
      ifull = 0
      do 10 ibig = 1,nrbig
      dobs = int(databig(ibig,dcol))
      eobs = int(databig(ibig,ecol))
      nsobs = lengthofs(dobs,int(eobs+1))
      do 20 is = 1,nsobs
      ifull = ifull + 1
      do 30 icbig = 1,ncbig
      datafull(ifull,icbig) = databig(ibig,icbig)
 30   continue
      datafull(ifull,ncfull) = whatofs(dobs,eobs+1,is)
 20   continue
 10   continue
      return
      end
C***************************************************************
      subroutine multinom2(nsim,n,ntotal,x,outvec)
C in is runiform, x=c(F(ix1),...,F(ixn)),F=cum distr
C ix=c(ix1,ix2...),  and if in<=x1, then out=ix(1),
C else if in<=x2, then out=ix(2) etc, otherwise out=-999
C outvec has to be initially 0 integers
C checked OK Sept 18th 2001
      integer n,i,j,isim,nsim,itemp,ntotal,outvec(nsim,n)
      double precision x(n),in
C      implicit none
      external place,generate
      do 50 isim=1,nsim
      do 40 j=1,ntotal
      in=0.0D0      
      call generate(in)
      do 10 i=1,n
         itemp=i
      if (in.le.x(i)) then  
C         success=1       
         go to 30          
      end if
10    continue
30    outvec(isim,itemp)=outvec(isim,itemp)+1
C      if (success.eq.0) then
C         out=-999.0D0
C      end if
40    continue
50    continue
      return
      end
C***************************************************************
      double precision function powd(a,tob)
	
      double precision a,tob
      powd=tob*log(a)
      powd=exp(powd)
      return
      end
C*********************************************************************
      double precision function logit(p)
      double precision p
C      implicit none
      logit=log(p/(1.0D0-p))
      return
      end 
C*********************************************************************    
      double precision function expit(x)
      double precision x
C      implicit none
      expit=exp(x)/(1.0D0+exp(x))
      return
      end 

C******************************************************************
      subroutine lkdfors(s,hs,zeta,delta,gamma,
     >  ns,nhs,pcum,p,lkd)
C calculates lkd=P(Si=s|X=hs) in prop. odds model with 
C S=1,...,ns modeled as
C logit(pr( Si =< s | Xi=hs))= zeta[s]+ hs*gamma  (see notes p.11)
C The inputs are zeta[1:ns], and delta[1:ns], where 
C   zeta(s)-zeta(s-1)=exp(delta(s)), so that the necessary inputs
C   are only zeta(1) and delta(2) ...delta(ns-1), and gamma(ns)
C   That is,  ns-1+nhs values.
c input
      integer ns,nhs
      double precision hs(nhs),zeta(ns),delta(ns),gamma(nhs),s
      
c local 
      integer is,ispre,sint,nsnew
      double precision dotmat,expit,logit,sum
c output
      double precision pcum(ns),p(ns),lkd
      external dotmat,expit,logit
C      implicit none
      
      sum=dotmat(hs,gamma,nhs)
      sint=int(s)
      p(1)=expit(zeta(1)+sum)
      pcum(1)=p(1)

      nsnew=ns-1
      do 50 is=2,nsnew
         ispre=is-1
         zeta(is)=zeta(ispre)+exp(delta(is))
         pcum(is)=expit(zeta(is)+sum)
         p(is)=pcum(is)-pcum(ispre)
50    continue
      pcum(ns)=1.0D0
      p(ns)=pcum(ns)-pcum(nsnew)

      lkd=p(sint)
      return
      end

C******************************************************************   
      subroutine lkdfory(y,hy,betay,nhy,lkd)
C calculates likelihood of logistic model, see notes p. 14
c input
      integer nhy
      double precision y,hy(nhy),betay(nhy)
c local 
      double precision dotmat,powd,expit,sum,p
c output
      double precision lkd
      external dotmat,powd,expit,logit
C      implicit none
      
      sum=dotmat(hy,betay,nhy)
      p=expit(sum)
      lkd=powd(p,y)*powd((1.0D0-p),(1.0D0-y))
      return
      end
C*********************************************************************
      subroutine estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,theta,
     > nsbig,nrfull,nrbig,nhs,nhy,nhc,ns,
     > pifull,loglik)
c input     
C theta=[zeta,delta,gamma,betac,betay]
      INTEGER nrfull,nrbig,nhs,nhy,nhc,ns
      INTEGER nsbig(nrbig)
      double precision hsfull(nrfull,nhs),hyfull(nrfull,nhy),
     > hcfull(nrfull,nhc)
      double precision sfull(nrfull),yfull(nrfull),cfull(nrfull)
      double precision theta(2*ns+nhs+nhy+nhc)
C local and called functions and subs
      integer kfull
      double precision hstemp(nhs),hytemp(nhy),hctemp(nhc)
      double precision stemp,ytemp,ctemp,pcum(ns),p(ns),lkds,lkdy,lkdc
      double precision lkdsyccum(nrbig)
      double precision zeta(ns),delta(ns),gamma(nhs),betay(nhy),
     > betac(nhc)
c output
      double precision pifull(nrfull), loglik
      external lkdfors, lkdfory, rowi
      
      kount=0 
      do 5 itheta=1,ns
      kount = kount+1
      zeta(kount) = theta(itheta)
 5    continue
      kount=0 
      do 6 itheta=ns+1,2*ns
      kount = kount+1
      delta(kount) = theta(itheta)
 6    continue
      kount=0 
      do 7 itheta=2*ns+1,2*ns+nhs
      kount = kount+1
      gamma(kount) = theta(itheta)
 7    continue
      kount=0 
      do 8 itheta=2*ns+nhs+1,2*ns+nhs+nhc
      kount = kount+1
      betac(kount) = theta(itheta)
 8    continue
      kount=0 
      do 9 itheta=2*ns+nhs+nhc+1,2*ns+nhs+nhc+nhy
      kount = kount+1
      betay(kount) = theta(itheta)
 9    continue


      kfull = 0
      loglik = 0.0d0
      do 10 ibig = 1,nrbig
      lkdsyccum(ibig) = 0.d0
      do 20 is = 1,nsbig(ibig)
         kfull = kfull + 1
         call rowi(hsfull,nrfull,nhs,kfull,hstemp)
         call rowi(hyfull,nrfull,nhy,kfull,hytemp)
         call rowi(hcfull,nrfull,nhc,kfull,hctemp)
         stemp = sfull(kfull)
         ytemp = yfull(kfull)
         ctemp = cfull(kfull)
         lkdy=1.0D0
         call lkdfors(stemp,hstemp,zeta,delta,gamma,ns,nhs,pcum,p,lkds)
         if(ctemp.le.(0.5D0)) call lkdfory(ytemp,hytemp,betay,nhy,lkdy)
         call lkdfory(ctemp,hctemp,betac,nhc,lkdc)

         pifull(kfull) = lkds*lkdy*lkdc
         lkdsyccum(ibig) = lkdsyccum(ibig) + pifull(kfull)
 20      continue
         loglik = loglik + log(lkdsyccum(ibig))
 10      continue
      kfull = 0 
      do 30 ibig = 1, nrbig  
      do 40 is = 1,nsbig(ibig)        
         kfull = kfull + 1
         pifull(kfull) = pifull(kfull)/lkdsyccum(ibig)
 40      continue
 30      continue
       return
       end
c  **********************************************************************
c  Constantine's subroutine to calculate Hessian of negative log-likelihood
c
      subroutine negdel2f2(hsfull,hyfull,hcfull,sfull,yfull,cfull,
     > beta,nsbig,nrfull,nrbig,nhs,nhy,nhc,ns,nsubset,subset,
     > varmat,del1,delfraction)
c input     
C theta=[zeta,delta,gamma,betac,betay]
      INTEGER nrfull,nrbig,nhs,nhy,nhc,ns,nsubset,subset(nsubset)
      INTEGER nsbig(nrbig)
      double precision hsfull(nrfull,nhs),hyfull(nrfull,nhy),
     > hcfull(nrfull,nhc)
      double precision sfull(nrfull),yfull(nrfull),cfull(nrfull)
      double precision beta(2*ns+nhs+nhy+nhc),delfraction
C computes negdel2=second deriv of negative log-likelihood
  
      
C local and called functions
   
      double precision pifull(nrfull),fbeta,fi,fj,fij 
      double precision betai(2*ns+nhs+nhy+nhc)
      double precision betaj(2*ns+nhs+nhy+nhc)
      double precision betaij(2*ns+nhs+nhy+nhc)
      double precision delbeta(2*ns+nhs+nhy+nhc)

C output
      double precision varmat(nsubset,nsubset),del1(nsubset)
      external estep
C      IMPLICIT NONE
      fbeta=0.0D0
      fi=0.0D0
      fj=0.0D0
      fij=0.0D0
     
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,beta,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,fbeta)
      
      do 10 i0=1,nsubset
         i=subset(i0)
         delbeta(i)=abs(beta(i))*delfraction
C        delbeta(i)=delfraction
         betai(i)=beta(i)
         betaj(i)=beta(i)
         betaij(i)=beta(i)
10    continue

C loop 20 does diagonal
C  betaij (fij) below will be beta (fbeta) perturbed with plus at i
C  betai (fi) below will be beta (fbeta) perturbed with minus at i
      do 20 i0=1,nsubset
         i=subset(i0)
         betaij(i)=beta(i)+delbeta(i)
         betai(i)=beta(i)-delbeta(i) 
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,betaij,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,fij)
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,betai,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,fi)
      
 
C first derivative:
      del1(i0)=(fij-fbeta)/delbeta(i) 
      del1(i0)=(del1(i0)+(fbeta-fi)/delbeta(i))/(2.0D0)
      varmat(i0,i0)=(fij-2.0D0*fbeta+fi)/(delbeta(i)**2)
C     reassign initial values to betas
      betaij(i)=beta(i)
      betai(i)=beta(i)
C      write (*,"i = ", i         
20    continue 

C loops 30,50 do off diagonals.
      do 50 i0=2,nsubset
      do 30 j0=1,(i0-1)
      i=subset(i0)
      j=subset(j0)
      betaij(i)=beta(i)+delbeta(i)
      betaij(j)=beta(j)+delbeta(j)
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,betaij,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,fij)
            
      betai(i)=beta(i)+delbeta(i)
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,betai,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,fi)

      betaj(j)=beta(j)+delbeta(j)
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,betaj,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,fj)

      varmat(i0,j0)=(fij-fi-fj+fbeta)/
     >   (delbeta(i)*delbeta(j))
      varmat(j0,i0)=varmat(i0,j0)
C     reassign initial values to betas
        betaij(i)=beta(i)
        betaij(j)=beta(j)
        betai(i)=beta(i)
        betaj(j)=beta(j)
30     continue
50     continue
       return
       end      
c  *********************************************************************
c Alan Genz's subroutine to calculate Hessian of negative log-likelihood
c
      subroutine negdel(hsfull,hyfull,hcfull,sfull,yfull,cfull,
     > X,nsbig,nrfull,nrbig,nhs,nhy,nhc,ns,N,subset,CV)
c input     
C theta=[zeta,delta,gamma,betac,betay]
      INTEGER nrfull,nrbig,nhs,nhy,nhc,ns,N,subset(N)
      INTEGER nsbig(nrbig)
      double precision hsfull(nrfull,nhs),hyfull(nrfull,nhy),
     > hcfull(nrfull,nhc)
      double precision sfull(nrfull),yfull(nrfull),cfull(nrfull)
      double precision X(2*ns+nhs+nhy+nhc),delfraction
C computes negdel2=second deriv of negative log-likelihood
     
C local and called functions
   
      double precision pifull(nrfull),FUN,FMM,FMP,FPP,FPM,FIP,FIM
	DOUBLE PRECISION XI,XJ,H,HI,HJ
	INTEGER I,J,IJ
	PARAMETER (H=1.D-04)

C output
      double precision CV(N,N)
      external estep
C      IMPLICIT NONE
     
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,X,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,FUN)

      IJ=0
      DO 10 I=1,N
	XI = X(I)
	HI = MAX(H*ABS(XI),H)

	DO 20 J = 1,I-1   
		IJ = IJ+1
		XJ = X(J)
		HJ = MAX(H*ABS(XJ),H)
		X(I) = XI - HI
		X(J) = XJ - HJ
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,X,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,FMM)
		X(J) = XJ + HJ
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,X,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,FMP)
		X(I) = XI + HI
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,X,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,FPP)
		X(J) = XJ - HJ
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,X,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,FPM)
		CV(I,J) = - (FPP-FMP-FPM+FMM)/(4.*HI*HJ)
		X(I) = XI - HI/2.
		X(J) = XJ - HJ/2.
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,X,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,FMM)
		X(J) = XJ + HJ/2.
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,X,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,FMP)
		X(I) = XI + HI/2.
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,X,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,FPP)
		X(J) = XJ - HJ/2.
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,X,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,FPM)
		CV(I,J) = (-4.* (FPP-FMP-FPM+FMM)/(HI*HJ) - CV(I,J) )/3.
		CV(J,I) = CV(I,J)
		X(J) = XJ
20		CONTINUE

	IJ = IJ + 1
	X(I) = XI - HI
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,X,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,FIM)
	X(I) = XI + HI
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,X,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,FIP)
	CV(I,I) = -(FIP+FIM-2*FUN)/HI**2	
	X(I) = XI - HI/2.
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,X,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,FIM)
	X(I) = XI + HI/2.
      call estep(hsfull,hyfull,hcfull,sfull,yfull,cfull,X,nsbig,
     > nrfull,nrbig,nhs,nhy,nhc,ns,pifull,FIP)
	CV(I,I) = (-16.* (FIP+FIM-2*FUN)/HI**2 - CV(I,I))/3.
	X(I) = XI	
10    CONTINUE	

       return
       end   
****************************************************************************************
